// tree logic
Random@ map_random = Random();

void onInit( CSprite@ this )
{
	this.SetZ(550.0f);
	this.RemoveSpriteLayer("leaves");
	CBlob@ blob = this.getBlob();
	


	for (uint i = 0; i < 5+map_random.NextRanged(8); i++)
	{
		CSpriteLayer@ leaves = this.addSpriteLayer( "leaves", this.getFilename(), 16, 16, 0, 0);
		if (leaves !is null)
		{
			u8 rnd = XORRandom(5);
			Animation@ anim = leaves.addAnimation("default", 6+(rnd*3), true);
			{
				int[] frames = {3,4,5,6,5,4,3};
				anim.AddFrames(frames);
			}
			leaves.SetRelativeZ(500.0f);
			leaves.SetOffset(blob.isFacingLeft() ?  Vec2f(0.5f,10.0f) :  Vec2f(0.0f,-10.0f));
			leaves.SetVisible(true);
			leaves.RotateBy(i*map_random.NextRanged(5), blob.isFacingLeft() ?  Vec2f(0.0f,-10.0f) :  Vec2f(0.5f,10.0f));
			leaves.RotateBy(i*(300+(60/(1+rnd))/(360)),blob.isFacingLeft() ?  Vec2f(0.0f,-10.0f) :  Vec2f(0.5f,10.0f));

			leaves.SetFacingLeft(XORRandom(2) == 0);
		}
	}
}

f32 onHit( CBlob@ this, Vec2f worldPoint, Vec2f velocity, f32 damage, CBlob@ hitterBlob, u8 customData )
{
	damage = 0.5f;
	return damage;
}

