
void onInit(CBlob@ this)
{
	this.set_f32("gib health", -3.0f);
	//this.Tag("player");

	this.getShape().SetRotationsAllowed(true);
	this.getShape().getConsts().net_threshold_multiplier = 0.5f;
	//this.getCurrentScript().tickFrequency = 2;
	this.set_Vec2f("next waypoint pos", this.getPosition()+ Vec2f(0, -128));
	this.set_Vec2f("last waypoint pos", this.getPosition());
}

CBlob@ getTarget(CBlob@ this)
{
	CBlob@[] blobsInRadius;
	if (this.getMap().getBlobsInRadius(this.getPosition(), this.getRadius() * 50.5f, @blobsInRadius))
	{
		for (uint i = 0; i < blobsInRadius.length; i++)
		{
			CBlob @b = blobsInRadius[i];
			if (b.getName() == "car")
			{
				return b;
			}
		}
	}
	return null;
}

void onTick(CBlob@ this)
{
	Vec2f mypos = this.getPosition();
	Vec2f nextpoint = this.get_Vec2f("next waypoint pos");
	Vec2f lastpoint = this.get_Vec2f("last waypoint pos");
	Vec2f[] waypoints;
	CMap@ map = getMap();	
	Vec2f targetPos = nextpoint;
	f32 angle = this.getAngleDegrees();

	u32 ticktime = (getGameTime());

	f32 angleOffset = 270.0f;
	f32 targetangle = (targetPos - mypos).getAngle();
	f32 angletotarget = (angle + targetangle + angleOffset) % 360;

	//if (map.getMarkers("waypoint", waypoints ) && (((mypos - nextpoint).Length() < 32.0f) || ((lastpoint - nextpoint).Length() < (lastpoint - mypos).Length())) ) 
	if (map.getMarkers("waypoint", waypoints ) && ((mypos - nextpoint).Length() < 16.0f) || ( mypos - nextpoint).Length() < (lastpoint - nextpoint).Length()/1.5)
	{		
		Vec2f nextWaypoint = nextpoint;
		f32 closestDist = 999999.9f;
		for (uint i=0; i < waypoints.length; i++)
		{
			Vec2f wpos = waypoints[i];
			if (wpos != nextpoint && wpos != lastpoint)
			{
				f32 dist = ( wpos - nextpoint ).Length();

				if (dist < closestDist)
				{					
					nextWaypoint = wpos;
					closestDist = dist;	
					this.set_Vec2f("next waypoint pos", nextWaypoint);									
				}
			}			
		}
			this.set_Vec2f("last waypoint pos", nextpoint);
		
	}

	this.setKeyPressed(key_left, false);
	this.setKeyPressed(key_right, false);
	this.setKeyPressed(key_up, true);
	this.setKeyPressed(key_action3, false);

	if ((angletotarget > 10 && angletotarget < 180))
	{
		this.setKeyPressed(key_left, true);
		//this.AddTorque(-25);
	}
	else if (angletotarget < 350 && angletotarget > 180)
	{
		this.setKeyPressed(key_right, true);
		//this.AddTorque(25);
	}
	Vec2f dir = Vec2f(0,-30*this.getVelocity().Length()).RotateBy(angle);
	Tile tile = map.getTile(mypos + dir);
	
	if (this.getVelocity().Length() > 3.0f && (tile.type < 400))
	{
		if(ticktime % 3 != 0)
		{
			this.setKeyPressed(key_up, false);
		}
	}

	
}

void onRender(CSprite@ this)
{
	CBlob@ blob = this.getBlob();
	Vec2f pos = blob.getPosition();
	Vec2f targetPos = blob.get_Vec2f("next waypoint pos");

	u32 ticktime = (getGameTime() + blob.getNetworkID());

	f32 angle = blob.getAngleDegrees();

	//Vec2f targetVector = (targetPos - pos);
	//f32 targetangle = targetPos.AngleWith(targetVector.RotateBy(-angle+90+15));
	f32 angleOffset = 270.0f;
	f32 targetangle = (targetPos - pos).getAngle();
	f32 angletotarget = (angle + targetangle + angleOffset) % 360;

	//Vec2f dir = Vec2f(0,-20*blob.getVelocity().Length()).RotateBy(angle);

	GUI::DrawArrow( pos, (blob.get_Vec2f("next waypoint pos")), SColor(255,0,255,0) );	
	//GUI::DrawArrow( pos, (blob.get_Vec2f("last waypoint pos")), SColor(255,255,0,0) );
	//GUI::DrawArrow( pos, (pos + dir), SColor(255,0,0,255) );

	//GUI::DrawText("myangle = "+ angle, Vec2f(getScreenWidth()-512, 148), color_white);

	//GUI::DrawText("target+angle = "+ (targetPos.AngleWith(targetVector)), Vec2f(getScreenWidth()-512, 164), color_white);

	//GUI::DrawText("angle-target = "+ (angletotarget), Vec2f(getScreenWidth()-512, 180), color_white);
}