#include "PlayerInfo.as";
#include "BaseTeamInfo.as";
#include "RulesCore.as";

void onTick(CBlob@ this)
{
	Vec2f mousepos = getControls().getMouseWorldPos();
	Vec2f mypos = this.getPosition();
	CSprite@ sprite = this.getSprite();
	CPlayer@ player = getLocalPlayer();
	CBlob@ localBlob = getLocalPlayerBlob();
	bool selected;
	
	bool mouseOnMe = (mousepos - mypos).getLength() < 8.0f;

	if (mouseOnMe)
	{
		sprite.setRenderStyle(RenderStyle::normal);
		if (localBlob !is null)
		{
			if (localBlob.isKeyJustPressed(key_action1) )
			{			
					
					localBlob.setPosition(this.getPosition());
				
				SelectedMe(this);
			}
		}
		else if ( localBlob is null && getControls().mousePressed1 )
		{
			SelectedMe(this);
			player.server_setTeamNum(0);
			player.client_RequestSpawn(0);
		}


	}
	else if (!mouseOnMe && localBlob !is null && localBlob.isKeyJustReleased(key_action1))
	{
		DeSelectedMe(this);
	}
	else if (isSelected(this))
	{		

		sprite.setRenderStyle(RenderStyle::normal);
	}
	else
	{
		sprite.setRenderStyle(RenderStyle::light);
	}
}

void SelectedMe(CBlob@ this)
{
	this.set_bool("selected", true);
}
void DeSelectedMe(CBlob@ this)
{
	this.set_bool("selected", false);
}

bool isSelected(CBlob@ this)
{
	return this.get_bool("selected");
}