/*
void onRender(CSprite@ this)
{
	CMap@ map = getMap();

	CBlob@ blob = this.getBlob();
	CBlob@ localBlob = getLocalPlayerBlob();
	if(localBlob is blob)
	{
		Vec2f pos = blob.getPosition();
		Vec2f vel = blob.getVelocity();
		float angle = blob.getAngleDegrees();

	 	Vec2f velocity_vec = vel.RotateBy(angle * -1);	 	
	 	float velocity_angle = (velocity_vec.getAngleDegrees()-90.0f);

	 	if (velocity_angle < 0.0f)
			velocity_angle = Maths::Abs(velocity_angle);

		f32 dif = Maths::Abs(velocity_angle-180.0f); //slide amount
		if (dif > 90)
			dif -= 180;
		if (dif < 0)
			dif = dif*-1;

		GUI::SetFont("menu");
		GUI::DrawArrow( pos, pos + velocity_vec, SColor(0xff9dca22) );	
		//GUI::DrawText("vx = "+ velocity_angle, Vec2f(getScreenWidth()-512, 148), color_white);	

		GUI::DrawText("dif = "+ vel.Normalize(), Vec2f(getScreenWidth()-512, 164), color_white);
	}
}
/*
You've got the blob's angle relative to "normal orientation" right? And you've got the velocity in "normal orientation".
To get the velocity in "blob orientation", we need to reverse the blob orientation. We can do this just but rotating the vector by the negative of the blob's angle.

We can get the vector (1,0) relative to that blob's orientation like so:

Once the velocity vector is already orientated to the correct angle,
then you can now break the velocity vector into x and y velocity vector.
This is now where you use trigonometry if doing it by hand knowing the velocity vector and the angle of orientation.

public static void KillOrthogonalVelocity(Car car, float drift = 0f)
{
    Vector2 forwardVelocity = car.Forward * Vector2.Dot(car.Velocity, car.Forward);
    Vector2 rightVelocity = car.Right * Vector2.Dot(car.Velocity, car.Right);
    car.Velocity = forwardVelocity + rightVelocity * drift;
}